import { Directive, Injectable, Input, ElementRef, AfterContentInit } from '@angular/core';
import { EventManager } from '@angular/platform-browser';
import { Angulartics2 } from './angulartics2';
export class Angulartics2On {
    constructor(elRef, angulartics2, eventManager) {
        this.elRef = elRef;
        this.angulartics2 = angulartics2;
        this.eventManager = eventManager;
        this.el = this.elRef.nativeElement;
    }
    ngAfterContentInit() {
        if (this.isBrowser()) {
            this.eventManager.addEventListener(this.el, this.angulartics2On || 'click', (event) => this.eventTrack(event));
        }
    }
    isBrowser() {
        return typeof (window) !== 'undefined';
    }
    eventTrack(event) {
        const action = this.angularticsEvent;
        const properties = {
            eventType: event.type
        };
        if (this.angularticsCategory) {
            properties.category = this.angularticsCategory;
        }
        if (this.angularticsProperties) {
            Object.assign(properties, this.angularticsProperties);
        }
        this.angulartics2.eventTrack.next({
            action,
            properties
        });
    }
}
//# sourceMappingURL=angulartics2On.js.map