import { Injectable } from '@angular/core';
import { GaEnhancedEcomProductFieldObject, GaEnhancedEcomAction, GaEnhancedEcomActionFieldObject, GaEnhancedEcomImpressionFieldObject } from './angulartics2-ga-enhanced-ecom-options';
var Angulartics2GoogleAnalyticsEnhancedEcommerce = /** @class */ (function () {
    function Angulartics2GoogleAnalyticsEnhancedEcommerce() {
    }
    /**
     * Add impression in GA enhanced ecommerce tracking
     * @name ecAddImpression
     *
     * @param {GaEnhancedEcomImpressionFieldObject} properties
     *
     * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/enhanced-ecommerce#measuring-activities
     */
    /**
       * Add impression in GA enhanced ecommerce tracking
       * @name ecAddImpression
       *
       * @param {GaEnhancedEcomImpressionFieldObject} properties
       *
       * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/enhanced-ecommerce#measuring-activities
       */
    Angulartics2GoogleAnalyticsEnhancedEcommerce.prototype.ecAddImpression = /**
       * Add impression in GA enhanced ecommerce tracking
       * @name ecAddImpression
       *
       * @param {GaEnhancedEcomImpressionFieldObject} properties
       *
       * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/enhanced-ecommerce#measuring-activities
       */
    function (properties) {
        ga('ec:addImpression', properties);
    };
    /**
     * Add product in GA enhanced ecommerce tracking
     * @name ecAddProduct
     *
     * @param {GaEnhancedEcomProductFieldObject} product
     *
     * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/ecommerce
     */
    /**
       * Add product in GA enhanced ecommerce tracking
       * @name ecAddProduct
       *
       * @param {GaEnhancedEcomProductFieldObject} product
       *
       * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/ecommerce
       */
    Angulartics2GoogleAnalyticsEnhancedEcommerce.prototype.ecAddProduct = /**
       * Add product in GA enhanced ecommerce tracking
       * @name ecAddProduct
       *
       * @param {GaEnhancedEcomProductFieldObject} product
       *
       * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/ecommerce
       */
    function (product) {
        ga('ec:addProduct', product);
    };
    /**
     * Set action in GA enhanced ecommerce tracking
     * @name ecSetAction
     *
     * @param {GaEnhancedEcomAction} action
     * @param {GaEnhancedEcomActionFieldObject} properties
     *
     * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/ecommerce
     */
    /**
       * Set action in GA enhanced ecommerce tracking
       * @name ecSetAction
       *
       * @param {GaEnhancedEcomAction} action
       * @param {GaEnhancedEcomActionFieldObject} properties
       *
       * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/ecommerce
       */
    Angulartics2GoogleAnalyticsEnhancedEcommerce.prototype.ecSetAction = /**
       * Set action in GA enhanced ecommerce tracking
       * @name ecSetAction
       *
       * @param {GaEnhancedEcomAction} action
       * @param {GaEnhancedEcomActionFieldObject} properties
       *
       * @link https://developers.google.com/analytics/devguides/collection/analyticsjs/ecommerce
       */
    function (action, properties) {
        ga('ec:setAction', action, properties);
    };
    return Angulartics2GoogleAnalyticsEnhancedEcommerce;
}());
export { Angulartics2GoogleAnalyticsEnhancedEcommerce };
//# sourceMappingURL=angulartics2-ga-enhanced-ecom.js.map